/* cbufs.c */

struct _stck_t {
    char *buf, *cbuf, *ebuf, *sbuf, *elast, *lke;
    etp *buf2;
    int buf2p, ebuf2, lkt;
    char *name;
};
typedef struct _stck_t stck;

struct _hash_t {
    char **sval;
    long *tval;
    long pos, maxpos;
    char *name;
};
typedef struct _hash_t hash;

struct _simstck_t {
    int *buf;
    int bufp, ebuf;
    char *name;
};
typedef struct _simtck_t simtck;


simtck *new_buf_sim_stack(long sz1, char *name);
void flush_sbuf(simtck * t);
void free_sbuf(simtck * t);
void push(simtck * b, int v);
int pop(simtck * b);

stck *new_buf_stack(long sz1, long sz2, char *name);
void flush_buf(stck * t);
void free_buf(stck * t);
void pushb(stck * b, char *s, etp tt);


void pushbe(stck * b, char *s);
void pushbt(stck * b, etp tt);
char *popb(stck * b, etp * tt);
char *popbe(stck * b);
etp popbt(stck * b);
void begin_scan(stck * b);
char *scan(stck * b);
char *lscan(stck * b, etp * tt);
etp lookback(stck * b);
void setl(stck * b);
//void stack_show(stck *b);
char *hash_by_val(hash * t, long val);
long hash_by_iname(hash * t, char *name);
long hash_by_name(hash * t, char *name);
void deleteh(hash * t);
void freeh(hash * t);
void addh(hash * t, char *n, long v);
void addhr(hash * t, char *n, long v);
hash *new_buf_hash(long sz1, char *name);
