// global variables of universal purpose
#include <stdio.h>
int RA, RB, RC;

enum ctx_keys {
    ctx_PART_NAME = 1,		// array name, used in tumble()
    ctx_UPPER_SCOPE = 2,
};

enum sym_flg {
    sf_INSIDE_TYPE = 1 << 0,
    sf_NO_AUTO_DEC = 1 << 1,
    sf_COMPLX_NAME = 1 << 2,
    sf_EMPTY_ELIST = 1 << 3,
    sf_EXPL_INIVAL = 1 << 4,
    sf_LEFT_SIDENM = 1 << 5,
    sf_NODEC = 1 << 6,
    sf_INSIDE_LET = 1 << 7,	//to use proper type in autodeclar. ( a=b: use type of b for a)
    sf_BEGINCD = 1 << 8,
    sf_ALLOW_REDEC = 1 << 9,	//allow name redeclaration (for overloaded subs)  
    sf_CONSTR_ARGS = 1 << 10	//there are args left on the stack for constructor  
};

enum arr_flg {
    af_DYNAMIC = 1 << 0,
    af_WRAP = 1 << 1,
    af_CHECK = 1 << 2,
    af_RESIZE = 1 << 3
};


FILE *out, *dec;
#define stANY 101
#define tVOID 102
#define tBYTE 103
#define tINT 104
#define tWORD 105
#define tLONG 106
#define tDWORD 107
#define tREAL 108
#define tDBL 109
#define tSTR 110
#define tMAX 111

#define tIS_INT(x) (x==tINT || x==tWORD || x==tLONG || x==tDWORD || x==tBYTE)
#define tIS_DBL(x) (x==tDBL || x==tREAL)


#define cSPEC 1
#define cCONST 2
#define cSCALAR 3
#define cARRAY 4
#define cSPTR 5
#define cFUN 6
long flof(FILE * fp);
void put2f(FILE * dst, char *name);
void f2f(FILE * dst, FILE * src);
void check_file_num(int n);

extern long lineno, last_symp;
extern int c_tp, c_cl, cscope;
extern char *nout, *ndec, *ntmp, *ntmp1, *ntmp2, *linfo_name, *nsub;

extern char spref[64];

extern char *lcase(char *);
extern FILE *tmp1, *tmp2, *tmp, *sub;
extern int req_adr, _mc, _pub;




// error reporting
#define mERR 0							     //error
#define mWRN 1							     //warning
#define mNOT 2							     //notification
#define mHLT 4							     //severe error

void msgrep(int msgtype, const char *g, ...);
