/* sym_arr.c */

union dims_t {
    char **dim_e;		// range subscripts as compiled to C expressions
    long *dim_v;		// or numbers, if array is static 
};

struct arr_d_ {
    int flg;			// array-specific flags 
    union dims_t d;
};

typedef struct arr_d_ arr_d;

#ifndef ARR_T_
#define ARR_T_
struct arr_t_ {
    char flg;
    int tp;			// type of data
    unsigned short int dims;	// number of dimens.
};

typedef struct arr_t_ arr_t;
#endif


extern arr_t *arp;

void init_ar(void);
void free_ar(void);

int alloc_arr_type(int dt, int dm, char flg, int emc);
