/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
File input/output support. Looks like a kludge. 
I'm going to rewrite this from the ground
*/

#include <string.h>
#include "glb.h"
#include "sym.h"
#include "cbufs.h"
#include "igo.h"

extern hash *fileh, *sfileh, *tfileh;

void fio_open(int mode, int p)
{
    etp tl, tr;
    char *l, *r, *m, *c;
    int n;
    l = strdup(popb(stk0, &tl));
    r = strdup(popb(stk0, &tr));
    if (tl.cl > cSCALAR || tl.tp != tINT)
	msgrep(mERR, "Invalid file specificator");
    if (tr.cl > cSCALAR || tr.tp != tSTR)
	msgrep(mERR, "Invalid file name");

    if (p && mode >= 3)
	msgrep(mERR,
	       "Invalid mode for OPEN PIPE - only INPUT and OUTPUT modes are valid");
    switch (mode) {
    case 1:
	m = "w";
	break;
    case 2:
	m = "r";
	break;
    case 3:
	m = "a";
	break;
    case 4:
	m = "w+";
	break;
    }
    n = atoi(l);
    if (p) {
	c = (char *) malloc(3);
	sprintf(c, "p%c", *m);
    } else
	c = strdup(m);

    if (strlen(hash_by_val(fileh, n)) == 0) {
	addhr(fileh, c, n);
	fprintf(dec, "FILE* _fh_%d_s;\n", n);
    }

    if (p)
	fprintf(out, "if (!(_fh_%d_s=popen(%s,\"%c\"))) _errf=ERR_OPEN;\n",
		n, r, *m);
    else
	fprintf(out, "if (!(_fh_%d_s=fopen(%s,\"%c\"))) _errf=ERR_OPEN;\n",
		n, r, *m);

    free(r);
    free(l);
}

void fio_close(int num)
{
    char *m;
    m = hash_by_val(fileh, num);
    if (strlen(m) == 0)
	msgrep(mERR, "Unknown file number - %d", num);
    if (*m == 'p')
	fprintf(out, "pclose(_fh_%d_s);\n", num);
    else
	fprintf(out, "fclose(_fh_%d_s);\n", num);
}

void fio_close_all(int num)
{
}

void check_file_num(int n)
{
    char *m;
    m = hash_by_val(fileh, n);
    if (strlen(m) == 0)
	msgrep(mERR, "Unknown file number - %d", n);
}

char *reformat(char *s)
{
    char *t, *u, *ot;
    t = (char *) calloc(strlen(s) * 2 + 1, 1);
    ot = t;
    s++;
    *t = '"';
    t++;
    while (*s != '`') {
	if (*s == '"') {
	    *t = '\\';
	    t++;
	    *t = '"';
	}
	*t = *s;
	t++;
	s++;
    }
    *t = '"';
    u = strdup(ot);
    free(ot);
    return u;
}
