/*
This file is a part of Lemick Basic (C) Copyright Alex Iliasov 2001.
this file should conatain code for various checks and etc. but now
almost nothing have been done
*/

#include "glb.h"
#include "sym.h"
#include "msg.h"
int lg_type(etp t)
{
    switch (t.cl) {
    case cSCALAR:
	return t.tp;
    case cARRAY:{
	    return arp[t.tp].tp;
	}
    }
    return tINT;
}


int select_class(int c1, int c2)
{
    if (c1 == c2)
	return c1;
    if (c2 > c1)
	return c2;
    else
	return c1;
}

int select_type(int c1, int c2)
{
    if (c1 == c2)
	return c1;
    if (c1 == tSTR && c2 != tSTR)
	msgrep(mERR, "incompatible types:%s, %s", msg_type(c1),
	       msg_type(c2));
    if (c2 > c1)
	return c2;
    else
	return c1;
}

long flof(FILE * fp)
{
    long ts, res;
    ts = ftell(fp);
    fseek(fp, 0, SEEK_END);
    res = ftell(fp);
    fseek(fp, ts, SEEK_SET);
    return res;
}

void vrf_tc(etp a, etp b)
{
    if ((a.cl == b.cl) || (a.cl == cCONST && b.cl == cSCALAR)) {
	if (a.tp == b.tp)
	    return;
	if (tIS_INT(a.tp) && tIS_INT(b.tp)) {
	    if (a.tp < b.tp)
		return;
	    else {
		msgrep(mWRN,
		       "Type casting between %s and %s types may lead to loss of significant bytes.",
		       msg_type(a.tp), msg_type(b.tp));
		return;
	    }
	}
	if (tIS_DBL(a.tp) && tIS_DBL(b.tp)) {
	    if (a.tp < b.tp)
		return;
	    else {
		msgrep(mWRN,
		       "Type casting between %s and %s types may lead to loss of significant bytes.",
		       msg_type(a.tp), msg_type(b.tp));
		return;
	    }
	}
	if (tIS_INT(a.tp) && tIS_DBL(b.tp))
	    return;
	if (tIS_DBL(a.tp) && tIS_INT(b.tp)) {
	    msgrep(mWRN,
		   "Type casting between %s and %s types may lead to loss of significant bytes.",
		   msg_type(a.tp), msg_type(b.tp));
	    return;
	}
	msgrep(mERR, "Can't convert between %s and %s types",
	       msg_type(a.tp), msg_type(b.tp));
    }
    msgrep(mWRN, "Can't convert between %s and %s classes",
	   msg_class(a.cl), msg_class(b.cl));
}
