/* sym_fun.c */
void init_fn(void);
void free_fn(void);
void enter_fun_dec(int rnc, int flg);
void leave_fun_dec(void);
void write_fun_dec(int);
etp fune_call_nov(const char *, int, int);
etp fune_call(const char *, int, int);
etp fune_call_plain(const char *, int, int);
void call_write();
long look_sub(char *name, int scope, int p);


enum fundec_flags {
    fdf_WRITE = 1 << 0,
    fdf_FUNCTION = 1 << 1,	//returns value
    fdf_DECLARE = 1 << 2,
    fdf_CD = 1 << 3,		//is a method (inside TYPE or CLASS)   
    fdf_DYNAMIC = 1 << 4,	//function body is in DSO
    fdf_EXTERN = 1 << 5,	//body of function is somewhere in library
    fdf_THREAD = 1 << 6		//compile as thread
};


struct _fun_t {
    char flg;			//function flags
    char *tflg;			//flags for each argument
    etp *typ;			//types and classes of arguments
    char **nom;			//names of arguments
    char **opt;			//list of OPTIONAL initialazers
    int pc, pceo;		//number of args. (incl./excl. optional)
};
typedef struct _fun_t fun_t;
